unit FormCSchemeGenerator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ShellCtrls, palette,SHP_engine_image, math;

type
  TFrmCSchemeGenerator = class(TForm)
    ShellTreeView1: TShellTreeView;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    author: TEdit;
    Label3: TLabel;
    website: TEdit;
    Label4: TLabel;
    Bevel1: TBevel;
    Button2: TButton;
    Button3: TButton;
    OpenPaletteDialog: TOpenDialog;
    Label5: TLabel;
    Game: TComboBox;
    Label6: TLabel;
    ShellTreeView2: TShellTreeView;
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function RGBDiff(C1,C2 : TColor):integer;
  private
    { Private declarations }
  public
    { Public declarations }
    OriginalPalette,ChangedPalette : TPalette;
  end;

var
  FrmCSchemeGenerator: TFrmCSchemeGenerator;

implementation

{$R *.dfm}

procedure TFrmCSchemeGenerator.Button3Click(Sender: TObject);
begin
Close;
end;

function TFrmCSchemeGenerator.RGBDiff(C1,C2 : TColor):integer;
var
r,g,b : integer;
begin

r := GetRValue(c1)-GetRValue(c2);
g := GetGValue(c1)-GetGValue(c2);
b := GetBValue(c1)-GetBValue(c2);
r := max(r,-r);
g := max(g,-g);
b := max(b,-b);

Result := R+G+B;

end;

procedure TFrmCSchemeGenerator.Button2Click(Sender: TObject);
var     f: TSearchRec;
        path: String;
    Filename : string;
    SL : TStringList;
    x : byte;
begin
     If edit1.Text = '' then
     exit;

     SL := TStringList.Create;
     path := Concat(ShellTreeView1.SelectedFolder.PathName+'\','*.pal');
     LoadAPaletteFromFile2(Edit1.text,OriginalPalette);

        // find files
     if FindFirst(path,faAnyFile,f) = 0 then repeat
     SL.Clear;

     Filename := Concat(ShellTreeView1.SelectedFolder.PathName+'\',f.Name);

     LoadAPaletteFromFile2(Filename,ChangedPalette);

     SL.Add('[Info]');
     SL.Add('Name='+copy(extractfilename(Filename),1,length(extractfilename(Filename))-4));
     SL.Add('By='+author.text);
     SL.Add('Website='+website.text);
     SL.Add('ImageIndex=-1');
     SL.Add('Split=false');
     SL.Add('gametype='+inttostr(Game.itemindex+1)); //1 = TS 2 = RA2 3 = YR 4 = PalPack1 5 = PalPack2
     SL.Add('schemetype=1'); // 1 = SHP Builder  2 = VXLSE
     SL.Add('');
     SL.Add('[Data]');

     for x := 0 to 255 do
     if (OriginalPalette[x] <> ChangedPalette[x]) and (RGBDiff(OriginalPalette[x],ChangedPalette[x]) > 10) then
     SL.Add(inttostr(x)+'='+inttostr(getpalettecolour2(OriginalPalette,ChangedPalette[x],OriginalPalette[0],1,true,false,false)))
     else
     SL.Add(inttostr(x)+'='+inttostr(x));
     SL.SaveToFile(ShellTreeView2.SelectedFolder.PathName + '\'+copy(extractfilename(Filename),1,length(extractfilename(Filename))-4)+'.cscheme');

     until FindNext(f) <> 0
     else
     showmessage('No *.pal files found in '+path);
        FindClose(f);

     close;
end;

procedure TFrmCSchemeGenerator.Button1Click(Sender: TObject);
begin
if OpenPaletteDialog.Execute then
edit1.Text := OpenPaletteDialog.FileName;
end;

procedure TFrmCSchemeGenerator.FormCreate(Sender: TObject);
begin
Game.ItemIndex := 0;
end;

end.
