unit FormCopyColour;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls,palette,shp_engine_image;

type
  TFrmCopyColours = class(TForm)
    PalettePanel: TPanel;
    cnvPalette: TPaintBox;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    StartColour: TSpinEdit;
    EndColour: TSpinEdit;
    Label5: TLabel;
    StartColour2: TSpinEdit;
    Label6: TLabel;
    EndColour2: TSpinEdit;
    procedure Button2Click(Sender: TObject);
    procedure cnvPalettePaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StartColourChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cnvPaletteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    OKS : Boolean;
    CPalette,CPalette2 : TPalette;
  end;

var
  FrmCopyColours: TFrmCopyColours;

implementation

uses FormMain;

{$R *.dfm}

procedure TFrmCopyColours.Button2Click(Sender: TObject);
begin
close;
end;

procedure TFrmCopyColours.cnvPalettePaint(Sender: TObject);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
    r: TRect;
begin
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     idx := 0;
     cnvPalette.Canvas.Brush.Color := clbtnface;
     cnvPalette.Canvas.FillRect(rect(0,0,cnvPalette.Width,cnvPalette.Height));
     for i := 0 to 8 do begin
         r.Left := (i * Round(colwidth));

         r.Right := (r.Left + Round(colwidth));
         for j := 0 to 31 do begin
             r.Top := (j * Round(rowheight));
             r.Bottom := (r.Top + Round(rowheight));
             with cnvPalette.Canvas do begin

                  Brush.Color := CPalette[idx];

                  if (Idx >= StartColour.Value) and (Idx <= StartColour.Value+EndColour.Value) then begin // the current pen
                     Pen.Color := OpositeColour(CPalette[idx]);
                     //Pen.Mode := pmNotXOR;
                     Rectangle(r.Left,r.Top,r.Right,r.Bottom);
                     MoveTo(r.Left,r.Top);
                     LineTo(r.Right,r.Bottom);
                     MoveTo(r.Right,r.Top);
                     LineTo(r.Left,r.Bottom);
                  end else
                  FillRect(r);
             end;
             Inc(Idx);
         end;
     end;
end;

procedure TFrmCopyColours.PaintBox1Paint(Sender: TObject);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
    r: TRect;
begin
     colwidth := Paintbox1.Width / 8;
     rowheight := Paintbox1.Height / 32;
     idx := 0;
     Paintbox1.Canvas.Brush.Color := clbtnface;
     Paintbox1.Canvas.FillRect(rect(0,0,Paintbox1.Width,Paintbox1.Height));
     for i := 0 to 8 do begin
         r.Left := (i * Round(colwidth));

         r.Right := (r.Left + Round(colwidth));
         for j := 0 to 31 do begin
             r.Top := (j * Round(rowheight));
             r.Bottom := (r.Top + Round(rowheight));
             with Paintbox1.Canvas do begin

                  Brush.Color := CPalette2[idx];

                  if (Idx >= StartColour2.Value) and (Idx <= StartColour2.Value+EndColour2.Value) then begin // the current pen
                     Pen.Color := OpositeColour(CPalette2[idx]);
                     //Pen.Mode := pmNotXOR;
                     Rectangle(r.Left,r.Top,r.Right,r.Bottom);
                     MoveTo(r.Left,r.Top);
                     LineTo(r.Right,r.Bottom);
                     MoveTo(r.Right,r.Top);
                     LineTo(r.Left,r.Bottom);
                  end else
                  FillRect(r);
             end;
             Inc(Idx);
         end;
     end;
end;

procedure TFrmCopyColours.Button1Click(Sender: TObject);
begin
OKS := true;
close;
end;

procedure TFrmCopyColours.StartColourChange(Sender: TObject);
begin
if ((((StartColour.Text = '') or (EndColour.Text = '')) or (StartColour2.Text = '')) or (EndColour2.Text = '')) then exit;
cnvPalette.Repaint;
PaintBox1.Repaint;
end;

procedure TFrmCopyColours.FormShow(Sender: TObject);
begin
OKS := false;
end;

procedure TFrmCopyColours.cnvPaletteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
begin
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     i := (X div round(colwidth));
     j := (Y div round(rowheight));
     idx := (i * 32) + j;

     // 1.2 code starts here
     //
     // Check if change is valid.
     if idx = StartColour.Value then exit;
     // Set end colour with shift or start colour without it.
     if ssShift in Shift then
     begin
        EndColour.Value := idx - StartColour.Value;
     end
     else
        StartColour.Value := idx;
end;

procedure TFrmCopyColours.PaintBox1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
begin
     colwidth := PaintBox1.Width / 8;
     rowheight := PaintBox1.Height / 32;
     i := (X div round(colwidth));
     j := (Y div round(rowheight));
     idx := (i * 32) + j;

     // 1.2 code starts here
     //
     // Check if change is valid.
     if idx = StartColour2.Value then exit;
     // Set end colour with shift or start colour without it.
     if ssShift in Shift then
     begin
        EndColour2.Value := idx - StartColour2.Value;
     end
     else
        StartColour2.Value := idx;
end;

end.
