unit FormMakeCScheme;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, palette;

type
TCScheme = record
        Data : array [0..255] of byte;
end;

type
  TFrmMakeCScheme = class(TForm)
    MainMenu1: TMainMenu;
    ools1: TMenuItem;
    File1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    LoadPal1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Panel1: TPanel;
    PalettePanel: TPanel;
    cnvPalette: TPaintBox;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    CopyColours1: TMenuItem;
    OpenPaletteDialog: TOpenDialog;
    Label3: TLabel;
    Author: TEdit;
    Label4: TLabel;
    Website: TEdit;
    Game: TComboBox;
    Label5: TLabel;
    CSName: TEdit;
    Label6: TLabel;
    SaveCSchemeDialog: TSaveDialog;
    procedure Exit1Click(Sender: TObject);
    procedure cnvPalettePaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure CopyColours1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LoadPal1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    OriginalPalette,ChangedPalette : TPalette;
    CScheme : TCScheme;
  end;

var
  FrmMakeCScheme: TFrmMakeCScheme;

implementation

uses FormCopyColour;

{$R *.dfm}

procedure TFrmMakeCScheme.Exit1Click(Sender: TObject);
begin
close;
end;

procedure TFrmMakeCScheme.cnvPalettePaint(Sender: TObject);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
    r: TRect;
begin
     colwidth := cnvPalette.Width / 8;
     rowheight := cnvPalette.Height / 32;
     idx := 0;
     cnvPalette.Canvas.Brush.Color := clbtnface;
     cnvPalette.Canvas.FillRect(rect(0,0,cnvPalette.Width,cnvPalette.Height));
     for i := 0 to 8 do begin
         r.Left := (i * Round(colwidth));

         r.Right := (r.Left + Round(colwidth));
         for j := 0 to 31 do begin
             r.Top := (j * Round(rowheight));
             r.Bottom := (r.Top + Round(rowheight));
             with cnvPalette.Canvas do begin

                  Brush.Color := OriginalPalette[idx];

                  FillRect(r);
             end;
             Inc(Idx);
         end;
     end;
end;

procedure TFrmMakeCScheme.PaintBox1Paint(Sender: TObject);
var colwidth, rowheight: Real;
    i, j, idx: Integer;
    r: TRect;
begin
     colwidth := PaintBox1.Width / 8;
     rowheight := PaintBox1.Height / 32;
     idx := 0;
     PaintBox1.Canvas.Brush.Color := clbtnface;
     PaintBox1.Canvas.FillRect(rect(0,0,PaintBox1.Width,PaintBox1.Height));
     for i := 0 to 8 do begin
         r.Left := (i * Round(colwidth));

         r.Right := (r.Left + Round(colwidth));
         for j := 0 to 31 do begin
             r.Top := (j * Round(rowheight));
             r.Bottom := (r.Top + Round(rowheight));
             with PaintBox1.Canvas do begin

                  Brush.Color := ChangedPalette[idx];

                  FillRect(r);
             end;
             Inc(Idx);
         end;
     end;
end;

procedure TFrmMakeCScheme.CopyColours1Click(Sender: TObject);
var
x,step,sv,svv : integer;
begin
for x := 0 to 255 do
begin
FrmCopyColours.CPalette[x] := OriginalPalette[x];
FrmCopyColours.CPalette2[x] := ChangedPalette[x];
end;

FrmCopyColours.Label6.Visible := true;
FrmCopyColours.endColour2.Visible := true;

FrmCopyColours.showmodal;

if FrmCopyColours.endColour.Value > FrmCopyColours.endColour2.Value then
Step := (FrmCopyColours.endColour.Value+1) div (FrmCopyColours.endColour2.Value+1)
else
Step := (FrmCopyColours.endColour2.Value+1) div (FrmCopyColours.endColour.Value+1);

svv:= 0;
sv := 0;

//showmessage(inttostr(step));

if FrmCopyColours.OKS = true then
if FrmCopyColours.endColour.Value = FrmCopyColours.endColour2.Value then
for x := FrmCopyColours.StartColour2.Value to FrmCopyColours.StartColour2.Value+FrmCopyColours.EndColour.Value do
begin
ChangedPalette[x] := OriginalPalette[x-FrmCopyColours.StartColour2.Value+FrmCopyColours.StartColour.Value];
CScheme.Data[x] := x-FrmCopyColours.StartColour2.Value+FrmCopyColours.StartColour.Value;
end
else
if FrmCopyColours.endColour.Value > FrmCopyColours.endColour2.Value then
for x := 0 to FrmCopyColours.EndColour2.Value do
begin
ChangedPalette[FrmCopyColours.StartColour2.value+x] := OriginalPalette[(x * Step)+FrmCopyColours.StartColour.Value];
CScheme.Data[FrmCopyColours.StartColour2.value+x] := (x * Step)+FrmCopyColours.StartColour.Value;
//showmessage(inttostr((x * Step)+FrmCopyColours.StartColour.Value));
end
else
for x := 0 to FrmCopyColours.EndColour2.Value do
begin

if sv >= step then
begin
svv:= svv+1;
sv := 0;
end;
sv := sv+1;
ChangedPalette[FrmCopyColours.StartColour2.value+x] := OriginalPalette[(svv)+FrmCopyColours.StartColour.Value];
CScheme.Data[FrmCopyColours.StartColour2.value+x] := (svv)+FrmCopyColours.StartColour.Value;
//showmessage(inttostr((x * Step)+FrmCopyColours.StartColour.Value));
end;


cnvPalette.Repaint;
PaintBox1.Repaint;
end;

procedure TFrmMakeCScheme.FormShow(Sender: TObject);
var
x : integer;
begin

if OpenPaletteDialog.Execute then
begin
LoadAPaletteFromFile2(OpenPaletteDialog.FileName,OriginalPalette);
LoadAPaletteFromFile2(OpenPaletteDialog.FileName,ChangedPalette);

for x := 0 to 255 do
CScheme.Data[x] := x; // Reset CScheme

Game.ItemIndex := 0;
Author.Text := '';
Website.Text := '';
CSName.Text := '';
end
else
Close;

end;

procedure TFrmMakeCScheme.LoadPal1Click(Sender: TObject);
var
x : integer;
begin

if OpenPaletteDialog.Execute then
begin
LoadAPaletteFromFile2(OpenPaletteDialog.FileName,OriginalPalette);
LoadAPaletteFromFile2(OpenPaletteDialog.FileName,ChangedPalette);
cnvPalette.Repaint;
PaintBox1.Repaint;

for x := 0 to 255 do
CScheme.Data[x] := x; // Reset CScheme

{Game.ItemIndex := 0;
Author.Text := '';
Website.Text := '';}
CSName.Text := '';
end
end;

procedure TFrmMakeCScheme.Save1Click(Sender: TObject);
var
S : TStringList;
x : integer;
begin
S := TStringList.Create;

if SaveCSchemeDialog.Execute then
begin
S.Add('[Info]');

S.Add('Name='+CSName.text);
S.Add('By='+author.text);
S.Add('Website='+website.text);
S.Add('ImageIndex=-1');
S.Add('Split=false');
S.Add('gametype='+inttostr(Game.itemindex));
S.Add('schemetype=1'); // 1 = SHP Builder  2 = VXLSE
S.Add('');
S.Add('[Data]');

for x := 0 to 255 do
S.Add(inttostr(x) +'='+inttostr(cscheme.data[x]));

S.SaveToFile(SaveCSchemeDialog.FileName);
end;
S.Free;
end;

end.
