// SHP_ENGINE.PAS
// By Banshee & Stucuk

unit Shp_Engine;

interface

uses
  Windows,Dialogs,SysUtils,Classes,ExtCtrls,Shp_File,Shp_Engine_Image,Palette;

Const
SHP_ENGINE_VER = '1.9';
SHP_ENGINE_BY = 'Banshee & Stucuk';

Procedure LoadSHP(Filename:String; var SHP : TSHP);
Function WorkOutOffset(SHP:TSHP; Frame:integer) : integer;
Procedure SaveSHP(Filename:String; var SHP : TSHP);
Procedure CompressFrameImage(SHP:TSHP;Frame:integer; var SHPData:TSHPData);
Procedure CompressFrameImages(var SHP:TSHP);
Procedure CreateFrameImage(var SHP: TSHP; const Frame: integer);
Procedure CreateFrameImages(var SHP: TSHP);
Procedure NewSHP(var SHP:TSHP; const TotalFrames,Width,Height : integer);
Function GetSHPType(SHP:TSHP) : String;


implementation

Procedure LoadSHP(Filename:String; var SHP : TSHP);
var
f : file;
read,x,c : integer;
colour : byte;
Databuffer,Databuffer2 : TDatabuffer;
Image_Size : cardinal;
begin

     AssignFile(F,Filename);  // Open file
     Reset(F,1); // Goto first byte?

     SHP.SHPType := stUnit;

     BlockRead(F,SHP.Header,Sizeof(SHP.Header)); // Read Header

     setlength(SHP.Data,SHP.header.NumImages+1); // Set the Data array to have SHP.header.NumImages+1 records

     if SHP.Header.NumImages = 1 then
     SHP.SHPType := stCameo; // If only one image assume cameo


     if (SHP.Header.NumImages < 7) and (SHP.Header.NumImages > 1) then
     SHP.SHPType := stBuilding; // If less than 7 but more than 1 assume building

     if (SHP.Header.NumImages < 100) and (SHP.Header.NumImages > 6) then
     SHP.SHPType := stAnimation; // If less than 100 but more than 6 assume animation

     // check extention to see if its actualy a TEM or SNO
     if extractfileext(Filename) = '.tem' then
     SHP.SHPType := sttem
     else
     if extractfileext(Filename) = '.sno' then
     SHP.SHPType := stsno;

     for x := 1 to SHP.header.NumImages do // Load Image Headers
     BlockRead(F,SHP.Data[x].header_image,Sizeof(THeader_Image));


     // Read and decode each image from the file
     for x := 1 to SHP.header.NumImages do
     begin

     // the ammount of bytes in a image (Width * Height)
     Image_Size := SHP.Data[x].header_image.cx*SHP.Data[x].header_image.cy;

     // Clear Buffers
     setlength(SHP.Data[x].Databuffer,0);
     setlength(Databuffer,0);
     setlength(Databuffer2,0);

     // Set the lengths of the data buffers
     setlength(SHP.Data[x].Databuffer,Image_Size+1);
     setlength(Databuffer,Image_Size+1);
     setlength(Databuffer2,Image_Size+1);

     Seek(F,SHP.Data[x].header_image.offset); // Goto the Line of the file that contains the start of the image

     // Read byte by byte SHP.Data[x].header_image.cy * SHP.Data[x].header_image.cx times
     for c := 1 to SHP.Data[x].header_image.cy * SHP.Data[x].header_image.cx do
     begin
     BlockRead(F,colour,Sizeof(byte),read);
     Databuffer[c-1] := colour;
     end;


     // If Compression3 try n decode it else databuffer2 = databuffer
     if SHP.Data[x].header_image.compression = 3 then
     Decode3(Databuffer,Databuffer2,SHP.Data[x].header_image.cx,SHP.Data[x].header_image.cy) // Compression 3
     else
     Databuffer2 := Databuffer; // Compression 1

     // Set the shp's databuffer to the result after decompression
     SHP.Data[x].Databuffer := Databuffer2;
     end;

     CloseFile(F);

end;

Function WorkOutOffset(SHP:TSHP; Frame:integer) : integer;
var
size,x: integer;
begin
size := 0;

size := SizeOf(THeader);

for x := 1 to SHP.Header.NumImages do
size := size+ SizeOf(THeader_Image);

if Frame > 1 then
for x := 1 to Frame-1 do
size := size + (SHP.Data[x].Header_Image.cx*SHP.Data[x].Header_Image.cy);

if SHP.Data[Frame].Header_Image.cx*SHP.Data[Frame].Header_Image.cy = 0 then
size := 0;

result := size;
end;

Procedure SaveSHP(Filename:String; var SHP : TSHP);
var
f : file;
Written,Writtent,x,c : integer;
b : byte;
Image_Size : cardinal;
begin
b := 0;
Writtent := 0;

     AssignFile(F,Filename);  // Open file
     Rewrite(F,1); // Goto first byte?

     BlockWrite(F,SHP.Header,Sizeof(THeader),Written); // Write Header
     Writtent := Writtent + Written;

     for x := 1 to SHP.header.NumImages do
     begin
     SHP.Data[x].header_image.offset := WorkOutOffset(SHP,X); // Works out offset
     SHP.Data[x].header_image.compression := 1;
     end;

     for x := 1 to SHP.header.NumImages do // Save Image Headers
     begin
     BlockWrite(F,SHP.Data[x].header_image,Sizeof(THeader_Image),Written);
     Writtent := Writtent + Written;
     end;

     // Save each image to the file
     for x := 1 to SHP.header.NumImages do
     begin

     // the ammount of bytes in a image (Width * Height)
     Image_Size := SHP.Data[x].header_image.cx*SHP.Data[x].header_image.cy;

     // Write byte by byte SHP.Data[x].header_image.cy * SHP.Data[x].header_image.cx times
     if SHP.Data[x].Header_Image.offset <> 0 then
     for c := 1 to Image_Size do
     begin
     BlockWrite(F,SHP.Data[x].Databuffer[c-1],Sizeof(byte),Written);
     Writtent := Writtent + Written;
     end;

     end;

     CloseFile(F);

end;

Procedure CreateFrameImage(var SHP: TSHP; const Frame: integer);
var
x,y,xx,yy,c : integer;
begin

//Clear Frame Image
Setlength(SHP.Data[Frame].FrameImage,0,0);

// Set FrameImage
Setlength(SHP.Data[Frame].FrameImage,SHP.Header.Width+1,SHP.Header.Height+1);

// Clear Frame
if SHP.Header.Width > 1 then
if SHP.Header.Height > 1 then
for y := 0 to SHP.Header.Height-1 do
for x := 0 to SHP.Header.Width-1 do
SHP.Data[Frame].FrameImage[1,1] := 0;

// Get the position of where to draw the frame from
xx := SHP.Data[Frame].header_image.x;
yy := SHP.Data[Frame].header_image.y;

c := -1;
if SHP.Data[Frame].header_image.cx*SHP.Data[Frame].header_image.cy > 0 then
for y := 0 to SHP.Data[Frame].Header_Image.cy-1 do
for x := 0 to SHP.Data[Frame].Header_Image.cx-1 do
begin
c := c +1;

SHP.Data[Frame].FrameImage[xx+x,yy+y] := shp.data[Frame].databuffer[c];
end;

end;

Procedure CreateFrameImages(var SHP: TSHP);
var
x : integer;
begin

for x := 1 to SHP.Header.NumImages do
CreateFrameImage(SHP,x);
end;

Procedure GetFrameImageUsedXY(SHP:TSHP;Frame:integer; var X1,Y1,X2,Y2:integer);
var
x,y : integer;
used : boolean;
begin
used := false;

X1 := SHP.Header.Width;
Y1 := SHP.Header.Height;
X2 := -1;
Y2 := -1;

for x := 0 to SHP.Header.Width-1 do
for y := 0 to SHP.Header.Height-1 do
if SHP.Data[frame].FrameImage[x,y] > 0 then
begin
if X1 > x then
X1 := x;
if X2 < x then
X2 := x;

if Y1 > Y then
Y1 := Y;
if Y2 < Y then
Y2 := Y;
used := true;
end;

if used = false then
begin
X1 := -1;
X2 := -1;
Y1 := -1;
Y2 := -1;
end;

end;

Procedure CompressFrameImage(SHP:TSHP;Frame:integer; var SHPData:TSHPData);
var
x1,x2,y1,y2,x,y,c : integer;
begin

GetFrameImageUsedXY(SHP,Frame,X1,Y1,X2,Y2);

if (X1 = -1) or (X2 = -1) or (Y1 = -1) or (Y2 = -1) then
begin
SHPData.Header_Image.cx := 0;
SHPData.Header_Image.cy := 0;
SHPData.Header_Image.x := 0;
SHPData.Header_Image.y := 0;
SHPData.Header_Image.unknown := 0;
SHPData.Header_Image.zero := 0;
end
else
begin

setlength(SHPData.Databuffer,0);
setlength(SHPData.Databuffer,(Y2-Y1+1)*(X2-X1+1)+1);

SHPData.Header_Image.cx := (X2-X1+1);
SHPData.Header_Image.cy := (Y2-Y1+1);
SHPData.Header_Image.x := X1;
SHPData.Header_Image.y := Y1;
SHPData.Header_Image.unknown := 0;
SHPData.Header_Image.zero := 0;

c := -1;
for y := Y1 to Y2 do
for x := X1 to X2 do
begin
c := c+1;
SHPData.Databuffer[c] := SHPData.FrameImage[x,y];
end;

if c > (Y2-Y1+1)*(X2-X1+1) then
showmessage(inttostr(c) + ' ' +inttostr((Y2-Y1)*(X2-X1)) + ' ' +inttostr(X1) + ' ' +inttostr(Y1) + ' ' +inttostr(X2) + ' ' +inttostr(Y2));

end;

end;

Procedure CompressFrameImages(var SHP:TSHP);
var
x : integer;
begin

for x := 1 to SHP.Header.NumImages do
CompressFrameImage(SHP,x,SHP.Data[x]);

end;

Procedure NewSHP(var SHP:TSHP; const TotalFrames,Width,Height : integer);
var
x : integer;
begin

// Clear then set the length of SHP's Data Array
setlength(SHP.Data,0);
setlength(SHP.Data,TotalFrames+1);

// Set SHP Width, Height and Frames
SHP.Header.Width := Width;
SHP.Header.Height := Height;
SHP.Header.NumImages := TotalFrames;

SHP.SHPType := stUnit; // Assume unit;

if SHP.Header.NumImages = 1 then
SHP.SHPType := stCameo; // If only one image assume cameo

if (SHP.Header.NumImages < 7) and (SHP.Header.NumImages > 1) then
SHP.SHPType := stBuilding; // If less than 7 but more than 1 assume building

if (SHP.Header.NumImages < 100) and (SHP.Header.NumImages > 6) then
SHP.SHPType := stAnimation; // If less than 100 but more than 6 assume animation

// Clear Header_Image
for x := 1 to TotalFrames do
begin
SHP.Data[x].Header_Image.cx := 0;
SHP.Data[x].Header_Image.cy := 0;
SHP.Data[x].Header_Image.x := 0;
SHP.Data[x].Header_Image.y := 0;
SHP.Data[x].Header_Image.compression := 1;
SHP.Data[x].Header_Image.offset := 0;
SHP.Data[x].Header_Image.zero := 0;
SHP.Data[x].Header_Image.unknown := 0;
end;

// Create the blank frame images
CreateFrameImages(SHP);

end;

Function GetSHPType(SHP:TSHP) : String;
begin
Result := '!ERROR!'; // Assume worst case scenario

If SHP.SHPType = stUnit then
result := 'Unit'
else
If SHP.SHPType = stcameo then
result := 'Cameo'
else
If SHP.SHPType = stBuilding then
result := 'Building'
else
If SHP.SHPType = stAnimation then
result := 'Animation'
else
If SHP.SHPType = stTem then
result := 'Tem'
else
If SHP.SHPType = stSno then
result := 'Sno';

end;

end.
 