// SHP_ENGINE_IMAGE.PAS
// By Banshee & Stucuk

{
14 Dec 2003 Stucuk: Fixed MoveFrameImagesDown, minor error.
17 Dec 2003 Stucuk: Added function GetBMPFromImageFile and Procedure Save_Bmp_As_Jpeg
18 Dec 2003 Stucuk: Added function SaveImageFileFromBMP
19 Dec 2003 Stucuk: Added procedure FrameImage_Section_Move


}

unit Shp_Engine_Image;

interface

uses
  Windows,Dialogs,SysUtils,ComCtrls,Classes,ExtCtrls,Shp_File,Palette,Graphics,math,Jpeg,Controls,PCXCtrl;

Const
 MaxAlg = 4; // Used in the auto select alg. Note: should b 4 when the 4th one is fixed.

// Misc Functions
Function IsShadow(SHP : TSHP; Frame:integer) : boolean;
Function GetShadowOposite(SHP:TSHP; Frame:integer) : integer;
Function GetShadowFromOposite(SHP:TSHP; Frame:integer) : integer;
Function HasShadows(SHP:TSHP) : boolean;
Function GetBMPOfFrameImage(SHP:TSHP;Frame:integer;Palette:TPalette):TBitmap;
Function GetBMPOfFrameImage_ShadowColour(SHP:TSHP;Frame:integer;Palette:TPalette):TBitmap;
function getpalettecolour(Palette: TPalette; Colour : Tcolor) : integer;
function getpalettecolour2(Palette: TPalette; Colour : Tcolor; BGColour:Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean) : integer;
function Insertblankframe_shadow(var SHP:TSHP;Const Frame : integer): integer;
function GetBMPFromImageFile(filename : string) : TBitmap;
function SaveImageFileFromBMP(filename : string; Bmp : TBitmap) : boolean;
Function AntiAlias_S2(Bitmap: tbitmap;BGColour : TColor) : TBitmap;
Function SetFrameImageFrmBMP2Diff(const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean) : integer;
function AutoSelectALG(Bitmap : TBitmap; BGColour : TColor; BcNone,ssShadow,ssIgnoreLAstColours : Boolean) : byte;
function AutoSelectALG_Progress(ProgressBar : TProgressBar; Bitmap : TBitmap; BGColour : TColor; BcNone,ssShadow,ssIgnoreLAstColours : Boolean) : byte;

// Misc Procedures
Procedure SetFrameImageFrmBMP(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap);
Procedure SetFrameImageFrmBMP2(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean);
Procedure SetFrameImageFrmBMP2NoBG(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreShadow,IgnoreGlowingColours:Boolean);
Procedure SetFrameImageFrmBMP2WithShadows(var SHP:TSHP; const Frame:integer;Bitmap : TBitmap; BGColour : Tcolor);
Procedure Insertblankframe(var SHP:TSHP;Const Frame : integer);
Procedure MoveFrameImagesUp(var SHP:TSHP; const Frame : integer);
Procedure ClearFrameImage(var SHP:TSHP;Const Frame : integer);
Procedure MoveFrameImagesDown(var SHP:TSHP; const Frame : integer);
Procedure Deleteframe(var SHP:TSHP;Const Frame : integer);
Procedure Deleteframe_shadow(var SHP:TSHP;Const Frame : integer);
Procedure Resize_Frame_Blocky(var SHP:TSHP; Frame,Width,Height:integer);
Procedure Resize_Frames_Blocky(var SHP:TSHP; Width,Height:integer);
Procedure Resize_Frames_Blocky_Progress(var SHP:TSHP; Width,Height:integer; Progress: TProgressbar);
Procedure Save_Bmp_As_Jpeg(const Bmp : TBitmap; JpgFileName: String);
Procedure FrameImage_Section_Move(var SHP : TSHP; Frame : integer; Source,Dest : TSelectArea);

// Canvas Procedures
Procedure CanvasResize(var Frame:TFrameImage; Width,Height,XBegin,YBegin,XEnd,YEnd:Integer; PaletteColour:byte);
Procedure CanvasPullHorizontal(var Frame:TFrameImage; MaxHeight,Position:Integer);
Procedure CanvasPullVertical(var Frame:TFrameImage; MaxWidth,Position:Integer);
Procedure CanvasPushHorizontal(var Frame:TFrameImage; MaxWidth,MaxHeight,Position:Integer);
Procedure CanvasPushVertical(var Frame:TFrameImage; MaxWidth,MaxHeight,Position:Integer);
Procedure CanvasCreateEmptyHorizontalQueue(var Frame:TFrameImage; MaxWidth,Position:Integer; PaletteColour:Byte);
Procedure CanvasCreateEmptyVerticalQueue(var Frame:TFrameImage; MaxHeight,Position:Integer; PaletteColour:Byte);
// Drawing Procedures
// Misc
function ColourToTRGB32(Colour:Tcolor) : TRGB32;
procedure SplitColour(raw: TColor; var red, green, blue: Byte);
function OpositeColour(color : TColor) : tcolor;
Function colourtogray(colour : cardinal): cardinal;

// Data From DataBuffer
Procedure DrawImageWithShadow(SHP: TSHP; Frame: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
Procedure DrawShadowWithImage(SHP: TSHP; Frame: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
Procedure DrawImage(SHP: TSHP; Frame: integer; Flood,Grayscale : boolean; Palette: TPalette; var Image1 : Timage);

// Data From FrameImage
Procedure DrawFrameImageWithShadow(SHP: TSHP; Frame, Zoom: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
Procedure DrawShadowWithFrameImage(SHP: TSHP; Frame, Zoom: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
Procedure DrawFrameImage(SHP: TSHP; Frame, Zoom: integer; Flood,Grayscale : boolean; Palette: TPalette; var Image1 : Timage);

// Using TPaintBox
Procedure DrawFrameImageCanvas(SHP: TSHP; Frame, Zoom: integer; Flood,Grayscale : boolean; Palette: TPalette; var PaintBox : TPaintBox);

//Cameo Procedures/Fuctions

// Built Following Blades RA2 Cameo Tutorial
procedure DrawCameoBar_DarkSide_Blade(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_LightSide_Blade(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_LightTop_Blade(var SHP:TSHP; Value : byte; ALG : integer);

// Built using Kravvitz's Cameos
procedure DrawCameoBar_Kravvitz(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_Kravvitz2(var SHP:TSHP; Value : byte; ALG : integer);

// 2
procedure DrawCameoBar_DarkSides_s1(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_LightSides_s1(var SHP:TSHP; Value : byte; ALG : integer);

// WW1
procedure DrawCameoBar_DarkSides_s2(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_LightSides_s2(var SHP:TSHP; Value : byte; ALG : integer);

// Misc
procedure DrawCameoBar_TextBar(var SHP:TSHP; Value : byte; ALG : integer);
procedure DrawCameoBar_TextBar2(var SHP:TSHP; Value : byte; ALG : integer);
Procedure DrawCameoText(Var SHP:TSHP; Const Text : string; ImageList : TImageList; ALG : integer);
Procedure DrawCameoText2(Var SHP:TSHP; Const Text : string; ImageList : TImageList; ALG : integer);
Procedure DrawEliteIconRA2(var SHP:TSHP; const ImageList : TImageList; EI, ALG : integer);
procedure DrawCameo_Transparent(var SHP:TSHP);
procedure DrawDark_Cameo(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
procedure DrawLight_Cameo(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
procedure DrawLight_Cameo2(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
Function WorkOutTextBarDV(SHP:TSHP) : integer;


implementation

// Misc

procedure SplitColour(raw: TColor; var red, green, blue: Byte);
begin
     red := (raw and $00FF0000) shr 16;
     green := (raw and $0000FF00) shr 8;
     blue := raw and $000000FF;
end;

function ColourToTRGB32(Colour:Tcolor) : TRGB32;
begin
result.R := GetRValue(Colour);
result.G := GetGValue(Colour);
result.B := GetBValue(Colour);
end;

function OpositeColour(Color : TColor) : TColor;
var
r,g,b : Byte;
NewColour : TColor;
begin

  R := 255-GetRValue(Color);
  G := 255-GetGValue(Color);
  B := 255-GetBValue(Color);

  NewColour := RGB(R,G,B);

  // If Same Colour then Pick Another.
  if (R = GetRValue(Color)) or (G = GetGValue(Color)) or (B = GetBValue(Color)) then
  NewColour := RGB(R+(GetRValue(color) div 2),G+(GetGValue(color) div 2),B+(GetBValue(color) div 2));

  // Fixes Prob With Gray On UnitTem.pal
  if ((R >120) and (R < 130)) or ((G >120) and (G < 130)) or ((B >120) and (B < 130)) then
  NewColour := RGB(R+(GetRValue(color) div 2),G+(GetGValue(color) div 2),B+(GetBValue(color) div 2));


  result := NewColour;
end;

Function IsShadow(SHP : TSHP; Frame:integer) : boolean;
var
shadow_start : integer;
begin
result := false;
// Shadows start half way through the file +1 frame
shadow_start := (SHP.Header.NumImages div 2)+1;

// Check to see if current frame is above or equal to the shadow start value
if frame >= shadow_start then
result := true;

if (SHP.SHPType = stCameo) then // Check if it is not a unit/building/animation.
result := false; // Only Units/buildings/animations have shadows

end;

Function GetShadowOposite(SHP:TSHP; Frame:integer) : integer;
var
shadow_start : integer;
begin
// Shadows start half way through the file
shadow_start := (SHP.Header.NumImages div 2);

if not IsShadow(SHP,Frame) then
result := 0 // Error;
else
result := Frame-shadow_start;
end;

Function GetShadowFromOposite(SHP:TSHP; Frame:integer) : integer;
var
shadow_start : integer;
begin
// Shadows start half way through the file
shadow_start := (SHP.Header.NumImages div 2);

result := Frame+shadow_start;
end;

Function HasShadows(SHP:TSHP) : boolean;
begin
Result := True; // Assume True

if (SHP.SHPType = stcameo) or (SHP.SHPType = sttem) or (SHP.SHPType = stsno) or (SHP.SHPType = stAnimation) then
Result := False;
end;

Function GetBMPOfFrameImage_ShadowColour(SHP:TSHP;Frame:integer;Palette:TPalette):TBitmap;
var
BMP :TBitmap;
x,y : integer;
begin
BMP := TBitmap.Create;


     // Set image width n height
     BMP.Width := SHP.header.Width;
     BMP.Height := SHP.header.Height;

     // Clear the image of colour (fills with the transparent colour)
     BMP.Canvas.Brush.Color := palette[TRANSPARENT];
     BMP.Canvas.FillRect(rect(0,0,BMP.Width,BMP.Height));

     // Populate the image pixel by pixel
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     BMP.Canvas.Pixels[x,y] := palette[1];
     end;

Result := BMP;
end;

Function GetBMPOfFrameImage(SHP:TSHP;Frame:integer;Palette:TPalette):TBitmap;
var
BMP :TBitmap;
x,y : integer;
begin
BMP := TBitmap.Create;
//Result := BMP; // Assume Worst Case


     // Set image width n height
     BMP.Width := SHP.header.Width;
     BMP.Height := SHP.header.Height;

     // Clear the image of colour (fills with the transparent colour)
     BMP.Canvas.Brush.Color := palette[TRANSPARENT];
     BMP.Canvas.FillRect(rect(0,0,BMP.Width,BMP.Height));

     // Populate the image pixel by pixel
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     BMP.Canvas.Pixels[x,y] := palette[shp.data[Frame].frameimage[x,y]];
     end;

Result := BMP;

end;

function getpalettecolour(Palette: TPalette; Colour : Tcolor) : integer;
var
p,col,ccol : integer;
r,g,b : byte;
t : single;
begin
col := -1;

for p := 0 to 255 do
if Colour = Palette[p] then
col := p;

t := 10000;

if col = -1 then
begin
ccol := -1;
for p := 0 to 255 do
begin

r := GetRValue(ColortoRGB(Colour)) - GetRValue(ColortoRGB(Palette[p])) ;
g := GetGValue(ColortoRGB(Colour)) - GetGValue(ColortoRGB(Palette[p])) ;
b := GetBValue(ColortoRGB(Colour)) - GetBValue(ColortoRGB(Palette[p])) ;

if Sqrt(r*r + g*g + b+b) < t then
begin
t := Sqrt(r*r + g*g + b+b);
ccol := p;
end;
end;

if (ccol = -1) or (t = 10000) then
ccol := TRANSPARENT;
col := ccol;
end;

result := col;
end;

Procedure AddLighting(var r,g,b: byte);
begin
   // If colour can receive some light, then...
   if ((r <= 252) and (g <= 252) and (b <= 252)) then
   begin
      r := r + 4;
      g := g + 4;
      b := b + 4;
   end;
end;

function GetBestColour2(Colour : TColor; SHPPalette : TPalette; start,final:byte) : byte;
type
TColourDifferenceArray = array [0..255] of record
        R,G,B,RT,GT,BT : integer;
end;
{TColourList = array [0..255] of record
        Colour: byte;
end;            }
var
r,g,b,r2,g2,b2,x,xx,start2 : byte;
ColourDifferenceArray : TColourDifferenceArray;
//ColourList : TColourList;
//ColourList_no : byte;
DifferenceTotal,r3,g3,b3 : integer;
begin

if start = 0 then
start2 := 1
else
start2 := start;

r := GetRValue(Colour);
g := GetGValue(Colour);
b := GetBValue(Colour);

// Populate Array
for x := Start to Final do
begin
ColourDifferenceArray[x].RT := r - GetRValue(SHPPalette[x]);
ColourDifferenceArray[x].GT := g - GetGValue(SHPPalette[x]);
ColourDifferenceArray[x].BT := b - GetBValue(SHPPalette[x]);
ColourDifferenceArray[x].R := max(ColourDifferenceArray[x].RT,-ColourDifferenceArray[x].RT);
ColourDifferenceArray[x].G := max(ColourDifferenceArray[x].GT,-ColourDifferenceArray[x].GT);
ColourDifferenceArray[x].B := max(ColourDifferenceArray[x].BT,-ColourDifferenceArray[x].BT);
end;

// Remove similer colours
{for x := Start to Final do
for xx := Start2 to Final do
if x <> xx then
if ColourDifferenceArray[x].RT <> 999999 then
if (ColourDifferenceArray[x].RT = ColourDifferenceArray[xx].RT) then
if (ColourDifferenceArray[x].GT = ColourDifferenceArray[xx].GT) then
if (ColourDifferenceArray[x].BT = ColourDifferenceArray[xx].BT) then
ColourDifferenceArray[xx].RT := 999999;     }


// Now we have reduced the list to only uniques find the best difference total

DifferenceTotal := 999999;

for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
if (ColourDifferenceArray[x].R + ColourDifferenceArray[x].G + ColourDifferenceArray[x].B) < DifferenceTotal then
DifferenceTotal := ColourDifferenceArray[x].R + ColourDifferenceArray[x].G + ColourDifferenceArray[x].B;

// Now we have the best difference value remove the rest

for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
if (ColourDifferenceArray[x].R + ColourDifferenceArray[x].G + ColourDifferenceArray[x].B) > DifferenceTotal then
ColourDifferenceArray[x].RT := 999999;        

// Find the lowest R,G,B values

r3 := 999999;
g3 := 999999;
b3 := 999999;

for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
if ColourDifferenceArray[x].R <= r3 then
if ColourDifferenceArray[x].G <= g3 then
if ColourDifferenceArray[x].B <= b3 then
begin
r3 := ColourDifferenceArray[x].R;
g3 := ColourDifferenceArray[x].G;
b3 := ColourDifferenceArray[x].B;
end;

// Remove colours with high differences

for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
if ColourDifferenceArray[x].R > r3 then
if ColourDifferenceArray[x].G > g3 then
if ColourDifferenceArray[x].B > b3 then
ColourDifferenceArray[x].RT := 999999;

// find the colour that matches the RGB difference

{for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
begin
result := x;
break;
end;       }


// If compleated below would create a colour list of the possible colour's
// Remove the colours with high R,G,B

{for x := Start to Final do
if ColourDifferenceArray[x].RT <> 999999 then
if Not((ColourDifferenceArray[x].R < r2) and (ColourDifferenceArray[x].G < g2) and (ColourDifferenceArray[x].B < b2)) then
ColourDifferenceArray[x].R := 999999;  }
end;

function GetBestColour(Colour : TColor; SHPPalette : TPalette; start,final:byte; rr,gg,bb : byte) : byte;
var
r,g,b,r2,g2,b2 : byte;
c,cc : integer;
begin

cc := -1;

r := GetRValue(Colour);
g := GetGValue(Colour);
b := GetBValue(Colour);

for c := start to 255 do
begin

r2 := GetRValue(SHPPalette[c]);
g2 := GetGValue(SHPPalette[c]);
b2 := GetBValue(SHPPalette[c]);
if (((r = r2) and (g = g2)) and (b = b2)) then
begin
cc := c;
break;
end
else
begin
if (max(r,r2) - min(r,r2)) <= rr then
if (max(g,g2) - min(g,g2)) <= gg then
if (max(b,b2) - min(b,b2)) <= bb then
begin
rr := max(r,r2) - min(r,r2);
gg := max(g,g2) - min(g,g2);
bb := max(b,b2) - min(b,b2);
cc := c;
end;
end;
end;

result := cc;

end;

function GetBestColourLight(Colour : TColor; SHPPalette : TPalette; start,final:byte; var rr,gg,bb:byte) : byte;
var
r,g,b,r2,g2,b2 : byte;
c,cc : integer;
begin

cc := -1;

r := GetRValue(Colour);
g := GetGValue(Colour);
b := GetBValue(Colour);
// the big difference. Result is lighter or distorted.
AddLighting(r,g,b);

for c := start to final do
begin

r2 := GetRValue(SHPPalette[c]);
g2 := GetGValue(SHPPalette[c]);
b2 := GetBValue(SHPPalette[c]);
if (((r = r2) and (g = g2)) and (b = b2)) then
begin
cc := c;
break;
end
else
begin
if (max(r,r2) - min(r,r2)) <= rr then
if (max(g,g2) - min(g,g2)) <= gg then
if (max(b,b2) - min(b,b2)) <= bb then
begin
rr := max(r,r2) - min(r,r2);
gg := max(g,g2) - min(g,g2);
bb := max(b,b2) - min(b,b2);
cc := c;
end;
end;
end;


result := cc;

end;

function getbestcolour_banshee(Colour : Tcolor;Palette: TPalette; start,final:byte; var t:integer) : integer;
var
p,col : integer; {p = counter, col: colour}
r,g,b,r0,b0,g0 : byte; {BitMap colour: (r, g, b), Palette (r0,g0,b0)}
begin
// Get values of the colour (translating it to SHP style)
r := (GetRValue(Colour) div 4) * 4;
g := (GetGValue(Colour) div 4) * 4;
b := (GetBValue(Colour) div 4) * 4;

// it the difference gets above 96, you get a transparent in
// your ass
col := -1;

// Here we start the search for the best colour.
for p := start to 255 do
begin
  r0 := GetRValue(Palette[p]);
  g0 := GetGValue(Palette[p]);
  b0 := GetBValue(Palette[p]);

  if (((r = r0) and (g = g0)) and (b = b0)) then
  begin
     // If the colour matches exactly, col receives p.
     col := p;
     t := 0;
     break;
  end
  else
  begin
     // if it doesnt match (as usual), it reads the p colours.
    // compare the sum of the differences between the bitmap
    // and palette colours
    if (abs(r - r0) + abs(g - g0) + abs(b - b0)) < t then
    begin
       t := abs(r - r0) + abs(g - g0) + abs(b - b0);
       col := p;
    end;
  end;
end;
// bye bye function, it's over... result is the number of the
// colour of the palette.
result := col;
end;

function getbestcolour_banshee_maxquality(Colour : Tcolor;Palette: TPalette; start,final:byte; var t:integer) : integer;
var
p,col : integer; {p = counter, col: colour}
r,g,b,r0,b0,g0 : byte; {BitMap colour: (r, g, b), Palette (r0,g0,b0)}
t0:integer; // Max difference allowed
begin
// Get values of the colour (without translation it to SHP style)
r := GetRValue(Colour);
g := GetGValue(Colour);
b := GetBValue(Colour);

// it the difference gets above 96, you get a transparent in
// your ass
col := -1;

// Here we start the search for the best colour.
for p := start to 255 do
begin
  r0 := GetRValue(Palette[p]);
  g0 := GetGValue(Palette[p]);
  b0 := GetBValue(Palette[p]);

  if (((r = r0) and (g = g0)) and (b = b0)) then
  begin
     // If the colour matches exactly, col receives p.
     col := p;
     t := 0;
     break;
  end
  else
  begin
     // if it doesnt match (as usual), it reads the p colours.
    // compare the sum of the differences between the bitmap
    // and palette colours
    t0 := round(sqrt((abs(r - r0) * abs(r - r0)) + (abs(g - g0) * abs(g - g0)) + (abs(b - b0) * abs(b - b0))));
    if t0 < t then
    begin
       t := t0;
       col := p;
    end;
  end;
end;
// bye bye function, it's over... result is the number of the
// colour of the palette.
result := col;
end;

procedure getpalettecolour3(Palette: TPalette; Colour : Tcolor; alg,start,final : byte; var col,t:integer; rr,gg,bb : byte);
begin
   if alg = 1 then
      col := GetBestColour(Colour,SHPPalette,start,final,rr,gg,bb)
   else if alg = 2 then
      col := GetBestColourLight(Colour,SHPPalette,start,final,rr,gg,bb)
   else if alg = 3 then
      col := getbestcolour_banshee(Colour,SHPPalette,start,final,t)
   else if alg = 4 then
      col := getbestcolour_banshee_maxquality(Colour,SHPPalette,start,final,t);
end;

function getpalettecolour2(Palette: TPalette; Colour : Tcolor; BGColour:Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean) : integer;
var
   col,t : integer;
   rr,gg,bb : byte;
begin

// reseting stuff
col := 0;
t := 9999;

rr := 255;
gg := 255;
bb := 255;

if (not (colour = bgcolour)) or (IgnoreBackground) then
begin
   // If it ignores shadows, the conversion starts on 2.
   if IgnoreGlowingColours then
   begin
      if not IgnoreShadow then
         getpalettecolour3(Palette,Colour,alg,1,1,col,t,rr,gg,bb);
      getpalettecolour3(Palette,Colour,alg,16,239,col,t,rr,gg,bb);
   end
   else
   begin
      if IgnoreShadow then
         getpalettecolour3(Palette,Colour,alg,2,255,col,t,rr,gg,bb)
      else
      if IgnoreBackground then
         getpalettecolour3(Palette,Colour,alg,0,255,col,t,rr,gg,bb)
      else
         getpalettecolour3(Palette,Colour,alg,1,255,col,t,rr,gg,bb);
   end;
end;

result := col;
end;

function getpalettecolour2Diff(Palette: TPalette; Colour : Tcolor; BGColour:Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean) : integer;
var
   col,t : integer;
   rr,gg,bb : byte;
begin

// reseting stuff
col := 0;
t := 9999;

if (not (colour = bgcolour)) or (IgnoreBackground) then
begin
   // If it ignores shadows, the conversion starts on 2.
   if IgnoreGlowingColours then
   begin
      if not IgnoreShadow then
         getpalettecolour3(Palette,Colour,alg,1,1,col,t,rr,gg,bb);
      getpalettecolour3(Palette,Colour,alg,16,239,col,t,rr,gg,bb);
   end
   else
   begin
      if IgnoreShadow then
         getpalettecolour3(Palette,Colour,alg,2,255,col,t,rr,gg,bb)
      else
         getpalettecolour3(Palette,Colour,alg,1,255,col,t,rr,gg,bb);
   end;
end;

rr := GetRValue(Colour) - GetRValue(SHPPalette[col]);
if rr < 0 then rr:= -rr;

gg := GetGValue(Colour) - GetGValue(SHPPalette[col]);
if gg < 0 then gg:= -gg;

bb := GetBValue(Colour) - GetBValue(SHPPalette[col]);
if bb < 0 then bb:= -bb;

result := rr+gg+bb;
end;

Procedure SetFrameImageFrmBMP2(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean);
var
x,y,maxH,maxW : integer;
begin
     maxH := min(SHP.Header.Height,Bitmap.Height);
     maxW := min(SHP.Header.Width,Bitmap.Width);

     // Populate the image pixel by pixel
     for y := 0 to maxH-1 do
     for x := 0 to maxW-1 do
     begin
     shp.data[Frame].frameimage[x,y] := getpalettecolour2(Palette,Bitmap.Canvas.Pixels[x,y],BGColour,alg,IgnoreBackground,IgnoreShadow,IgnoreGlowingColours);
     end;
end;

Function SetFrameImageFrmBMP2Diff(const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreBackground,IgnoreShadow,IgnoreGlowingColours:Boolean) : integer;
var
x,y,maxH,maxW : integer;
begin
     maxH := Bitmap.Height;
     maxW := Bitmap.Width;
     
     result := 0;

     for y := 0 to maxH-1 do
     for x := 0 to maxW-1 do
     begin
     result := result + getpalettecolour2Diff(Palette,Bitmap.Canvas.Pixels[x,y],BGColour,alg,IgnoreBackground,IgnoreShadow,IgnoreGlowingColours);
     end;
end;

Procedure SetFrameImageFrmBMP2NoBG(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap; BGColour : Tcolor; alg : byte; IgnoreShadow,IgnoreGlowingColours:Boolean);
var
x,y,maxH,maxW : integer;
begin
     maxH := min(SHP.Header.Height,Bitmap.Height);
     maxW := min(SHP.Header.Width,Bitmap.Width);

     // Populate the image pixel by pixel
     for y := 0 to maxH-1 do
     for x := 0 to maxW-1 do
     begin
     if Bitmap.Canvas.Pixels[x,y] <> BGColour then
     shp.data[Frame].frameimage[x,y] := getpalettecolour2(Palette,Bitmap.Canvas.Pixels[x,y],BGColour,alg,True,IgnoreShadow,IgnoreGlowingColours);
     end;
end;

Procedure SetFrameImageFrmBMP2WithShadows(var SHP:TSHP; const Frame:integer;Bitmap : TBitmap; BGColour : Tcolor);
var
x,y,maxH,maxW : integer;
begin
    maxH := min(SHP.Header.Height,Bitmap.Height);
    maxW := min(SHP.Header.Width,Bitmap.Width);

    // Populate the image pixel by pixel
    for y := 0 to maxH-1 do
    for x := 0 to maxW-1 do
    begin
       if Bitmap.Canvas.Pixels[x,y] = BGColour then
           shp.data[Frame].frameimage[x,y] := 0
       else
           shp.data[Frame].frameimage[x,y] := 1;
    end;
end;

Procedure Save_Bmp_As_Jpeg(const Bmp : TBitmap; JpgFileName: String);
var
  Jpg: TJPEGImage;
begin
  Jpg := TJPEGImage.Create;
  try
    Jpg.Assign(Bmp);
    Jpg.CompressionQuality := 100;
    Jpg.SaveToFile(JpgFileName);
  finally
    Jpg.Free;
  end;
end;

function GetBMPFromJPGImageFile(filename : string) : TBitmap;
var
JPEGImage: TJPEGImage;
Bitmap: TBitmap;
begin
Bitmap := TBitmap.Create;
JPEGImage := TJPEGImage.Create;

JPEGImage.LoadFromFile(Filename);
Bitmap.Assign(JPEGImage);

result := Bitmap;
end;

function GetBMPFromPCXImageFile(filename : string) : TBitmap;
var
PCXBitmap: TPCXBitmap;
Bitmap: TBitmap;
begin
Bitmap := TBitmap.Create;
PCXBitmap := TPCXBitmap.Create;

PCXBitmap.LoadFromFile(Filename);

Bitmap.Assign(PCXBitmap);

result := Bitmap;
end;

function GetBMPFromImageFile(filename : string) : TBitmap;
var
Bmp : TBitmap;
Ext : string;
begin
Bmp := TBitmap.Create;

Ext := ansilowercase(extractfileext(filename));

if Ext = '.bmp' then
Bmp.LoadFromFile(Filename);

if (Ext = '.jpg') or (Ext = '.jpeg') then
bmp := GetBMPFromJPGImageFile(Filename);

if (Ext = '.pcx') then
bmp := GetBMPFromPCXImageFile(Filename);

result := bmp;

end;

function SaveImageFileFromBMP(filename : string; Bmp : TBitmap) : boolean;
var
Ext : string;
begin

Ext := ansilowercase(extractfileext(filename));

result := true;

try
if Ext = '.bmp' then
Bmp.SaveToFile(Filename)
else
if (Ext = '.jpg') or (Ext = '.jpeg') then
Save_Bmp_As_Jpeg(Bmp,Filename)
else
result := false;
except
result := false;
end;

end;

procedure FrameImage_Section_Move(var SHP : TSHP; Frame : integer; Source,Dest : TSelectArea);
var
x,y,XDifference,YDifference : integer;
FrameImage : array of array of byte;
begin

XDifference := Max(Source.X1,Source.X2)-Min(Source.X1,Source.X2);
YDifference := Max(Source.Y1,Source.Y2)-Min(Source.Y1,Source.Y2);

SetLength(FrameImage,SHP.Header.Width,SHP.Header.Height);

for x := 0 to SHP.Header.Width-1 do
for y := 0 to SHP.Header.Height-1 do
if (x >= Min(Source.X1,Source.X2)) and (x <= Max(Source.X1,Source.X2)) and (y >= Min(Source.Y1,Source.Y2)) and (y < Max(Source.Y1,Source.Y2)) then
FrameImage[x,y] := 0
else
FrameImage[x,y] := SHP.Data[Frame].FrameImage[x,y];

for x := 0 to XDifference-1 do
for y := 0 to YDifference-1 do
if ((Min(Dest.X1,Dest.X2) + x) < SHP.Header.Width) and ((Min(Dest.Y1,Dest.Y2) + y) < SHP.Header.Height) then // Check its in range
if ((Min(Dest.X1,Dest.X2) + x) >= 0) and ((Min(Dest.Y1,Dest.Y2) + y) >= 0) then // Check its in range
begin

if ((Min(Source.X1,Source.X2) + x) < SHP.Header.Width) and ((Min(Source.Y1,Dest.Y2) + y) < SHP.Header.Height) and ((Min(Source.X1,Source.X2) + x) >= 0) and ((Min(Source.Y1,Source.Y2) + y) >= 0) then // Check its in range
FrameImage[Min(Dest.X1,Dest.X2) + x,Min(Dest.Y1,Dest.Y2) + y] := SHP.Data[Frame].FrameImage[Min(Source.X1,Source.X2) + x,Min(Source.Y1,Source.Y2) + y]
else
FrameImage[Min(Dest.X1,Dest.X2) + x,Min(Dest.Y1,Dest.Y2) + y] := 0; // Source is out fo bounds, defult to 0;

end;

for x := 0 to SHP.Header.Width-1 do
for y := 0 to SHP.Header.Height-1 do
SHP.Data[Frame].FrameImage[x,y] := FrameImage[x,y];

end;


Procedure SetFrameImageFrmBMP(var SHP:TSHP; const Frame:integer;Palette:TPalette;Bitmap : TBitmap);
var
x,y,maxH,maxW : integer;
begin


     maxH := min(SHP.Header.Height,Bitmap.Height);
     maxW := min(SHP.Header.Width,Bitmap.Width);
     // Clear the image of colour (fills with the transparent colour)
     //BMP.Canvas.Brush.Color := palette[TRANSPARENT];
     //BMP.Canvas.FillRect(rect(0,0,BMP.Width,BMP.Height));

     // Populate the image pixel by pixel
     for y := 0 to maxH-1 do
     for x := 0 to maxW-1 do
     begin
     shp.data[Frame].frameimage[x,y] := getpalettecolour(Palette,Bitmap.Canvas.Pixels[x,y]);
     end;
end;

Procedure ClearFrameImage(var SHP:TSHP;Const Frame : integer);
var
x,y : integer;
begin

for x := 0 to SHP.Header.Width-1 do
for y := 0 to SHP.Header.Height-1 do
SHP.Data[Frame].FrameImage[x,y] := 0;
end;

Procedure Insertblankframe(var SHP:TSHP;Const Frame : integer);
begin
MoveFrameImagesUp(SHP,Frame);
ClearFrameImage(SHP,Frame);
end;

function Insertblankframe_shadow(var SHP:TSHP;Const Frame : integer): integer;
var
owner,shadow : integer;
begin
if IsShadow(SHP,Frame) then
begin
shadow := Frame;
owner := GetShadowOposite(SHP,Frame);
end
else
begin
shadow := GetShadowFromOposite(SHP,Frame);
owner := Frame;
end;

MoveFrameImagesUp(SHP,owner);
ClearFrameImage(SHP,owner);

MoveFrameImagesUp(SHP,shadow+1);
ClearFrameImage(SHP,shadow+1);

result := owner;
end;

Procedure MoveFrameImagesUp(var SHP:TSHP; const Frame : integer);
var
x,xx,yy,c : integer;
begin
if Frame <1 then
exit;

if Frame > SHP.Header.NumImages then
exit;

SHP.Header.NumImages := SHP.Header.NumImages+1;
SetLength(SHP.Data,SHP.Header.NumImages+1);
SetLength(SHP.Data[SHP.Header.NumImages].FrameImage,SHP.Header.Width,SHP.Header.Height);

c := 0;
for x := Frame to SHP.Header.NumImages-1 do
begin
for xx := 0 to SHP.Header.Width-1 do
for yy := 0 to SHP.Header.Height-1 do
SHP.Data[SHP.Header.NumImages-c].FrameImage[xx,yy] := SHP.Data[SHP.Header.NumImages-1-c].FrameImage[xx,yy];
c := c +1;
end;

end;

Procedure MoveFrameImagesDown(var SHP:TSHP; const Frame : integer);
var
x,xx,yy : integer;
begin
if Frame <1 then
exit;

if Frame > SHP.Header.NumImages then
exit;

for x := Frame to SHP.Header.NumImages-1 do
begin
for xx := 0 to SHP.Header.Width-1 do
for yy := 0 to SHP.Header.Height-1 do
SHP.Data[x].FrameImage[xx,yy] := SHP.Data[x+1].FrameImage[xx,yy];
end;

SHP.Header.NumImages := SHP.Header.NumImages-1;
SetLength(SHP.Data,SHP.Header.NumImages+1);


end;

Procedure Deleteframe(var SHP:TSHP;Const Frame : integer);
begin
MoveFrameImagesDown(SHP,Frame);
end;

Procedure Deleteframe_shadow(var SHP:TSHP;Const Frame : integer);
var
owner,shadow : integer;
begin
if IsShadow(SHP,Frame) then
begin
shadow := Frame;
owner := GetShadowOposite(SHP,Frame);
end
else
begin
shadow := GetShadowFromOposite(SHP,Frame);
owner := Frame;
end;

Deleteframe(SHP,owner);
Deleteframe(SHP,shadow);
end;

Procedure Resize_Frame_Blocky(var SHP:TSHP; Frame,Width,Height:integer);
var
   cx,cy:integer; {current x and y, used as pointer for output.}
   x,y:integer; {counter x and y for input}
   Output: array of array of Byte; {this is a temporary matrix with the results, so I can have a reference of the original input}
   xmult,ymult:real; {multiplier of the width and height respectivelly}
   bx,by:integer; {counters used when increasing X or Y to fill the gaps}
   maxcx,maxcy:integer; {reference to max cx and cy when increasing X or Y}

begin
   // Some basic data first
   xmult := Width / SHP.Header.Width;
   ymult := Height / SHP.Header.Height;

   SetLength(Output,Width+1,Height+1); {now output has memory alocated to it :)}
   {This will be the blocky mode, the crappiest, but most versatile method so far}
   // Blocky Mode begins...

   // Lets start with our big and lovely friend X
   // Shrinking operation and Raising will differ a bit, that's why I need to detect
   // what kind of operation it will do.

   if (SHP.Header.Width >= Width) then {shrink X}
   begin
      // Now we have to know the same thing for our lovely friend Y
      if (SHP.Header.Height >= Height) then  {shrink Y}
      begin
         // This will be the easiest code :)
         // X and Y will be multiplied by the percentage and the botton frames will replace
         // the top frames if they coincide...

         // Lines first, then columns...
         for y := 0 to SHP.Header.Height-1 do
         begin
            cy := round(y * ymult);
            for x:= 0 to SHP.Header.Width-1 do
            begin
               cx := round(x * xmult);
               Output[cx,cy] := SHP.Data[Frame].FrameImage[x,y];
            end;
         end;
      end
      else if (SHP.Header.Height < Height) then {make Y bigger... I doubt someone will do something like that :P}
      begin
         // X will work like the code above, but Y will have a particular problem to be
         // solved. If you just multiply, there will be blank lines. So, we will need to
         // fill the gap with the previous line. This will give a blocky result, bad quality
         // but versatile.

	 // Lines first, then columns
	 for y := 0 to SHP.Header.Height-1 do
         begin
	    // Now, here comes the problem. "by" will be the counter used to detect when the
	    // line changes.
            by := 0; {resets counter}
	    // this is the minimum cy. "by" will be increased to fill the gaps.
	    cy := round(y * ymult);
            maxcy := round((y * ymult)+ymult);
  //          if (cy < 0) then cy := 0;

            while ((cy + by) <= maxcy) do
               // copy the current line to the position until it reachs the max cy
            begin
               for x := 0 to SHP.Header.Width-1 do
	       begin
	          cx := round(x * xmult);
		  Output[cx,cy + by] := SHP.Data[Frame].FrameImage[x,y];
	       end;
	       inc(by);
            end;
         end;
      end;
   end
   else if (SHP.Header.Width < Width) then {make X bigger}
   begin
      // Now we have to know the same thing for our lovely friend Y
      if (SHP.Header.Height >= Height) then  {shrink Y, another weirdo combination}
      begin
         // Y will work like the first code, but X will have the same particular problem
         // that Y had above. If you just multiply, there will be blank columns. So, we will
         // need to fill the gap with the previous columns. This will give a blocky result,
         // bad quality but versatile.

	 // Lines first, then columns
	 for y := 0 to SHP.Header.Height-1 do
         begin
            for x := 0 to SHP.Header.Width-1 do
            begin
               // Y is a piece of cake
               cy := round(y * ymult);

               // X Part (Big problem)
               bx := 0; {resets counter}
	             cx := round(x * xmult);
	             maxcx := round((x * xmult)+xmult);
// Removed:    if (cx < 0) then cx:=0; {avoids access violation}
//  Note: this access violation thing is useless. cx is never below 0.
	             while ((cx + bx) <= maxcx) do
               // copy the current line to the position until it reachs the max cx
                begin
	                 Output[cx + bx,cy] := SHP.Data[Frame].FrameImage[x,y];
                   inc(bx);
               end;
            end;
         end;
      end
      else if (SHP.Header.Height < Height) then {make Y bigger}
      begin
         // Both X and Y will have that particular problem above. If you just multiply them,
         // there will be blank lines and blank columns. So, we will need to fill the gaps
         // with the previous lines and columns. This will give a blocky result, bad
         // quality but versatile.

	 // Lines first, then columns
	 for y := 0 to SHP.Header.Height-1 do
         begin
	    // Y starts here.
            by := 0; {resets counter}
	          cy := round(y * ymult);
            maxcy := round((y * ymult)+ymult);
// Removed: if (cy < 0) then cy := 0;

            while ((cy + by) <= maxcy) do
            // copy the current line to the position until it reachs the max cy
            begin
               // X starts here
               for x := 0 to SHP.Header.Width-1 do
	             begin
                  bx := 0; {resets counter}
	                cx := round(x * xmult);
	                maxcx := round((x * xmult)+xmult);
// Removed:       if (cx < 0) then cx:=0; {avoids access violation}

    	            while ((cx + bx) <= maxcx) do
                  // copy the current line to the position until it reachs the max cx
                  begin
	                   Output[cx + bx,cy + by] := SHP.Data[Frame].FrameImage[x,y];
	                   inc(bx);
                  end;
	            end;
	         inc(by);
	         end;
        end;
      end;
   end;

   // Now, save the output in the SHP file.
   SetLength(SHP.Data[Frame].FrameImage,Width+1,Height+1);
   for y:=0 to Height do
      for x:=0 to Width do
          SHP.Data[Frame].FrameImage[x,y] := Output[x,y];
end;

Procedure Resize_Frames_Blocky(var SHP:TSHP; Width,Height:integer);
var
   x : integer;
begin

   for x := 1 to SHP.Header.NumImages do
      Resize_Frame_Blocky(SHP,X,Width,Height);

   SHP.Header.Width := Width;
   SHP.Header.Height := Height;
end;

Procedure Resize_Frames_Blocky_Progress(var SHP:TSHP; Width,Height:integer; Progress: TProgressbar);
var
   x : integer;
begin
   Progress.Max := SHP.Header.NumImages-1;
   Progress.Position := 0;

   for x := 1 to SHP.Header.NumImages do
   begin
      Resize_Frame_Blocky(SHP,X,Width,Height);
      Progress.Position := x-1; // Progressbar starts on 0 not 1.
      Progress.Refresh;
   end;

   SHP.Header.Width := Width;
   SHP.Header.Height := Height;
end;

// Canvas Procedures
Procedure CanvasResize(var Frame:TFrameImage; Width,Height,XBegin,YBegin,XEnd,YEnd:Integer; PaletteColour:byte);
begin
// The objective is to make XBegin, YBegin, XEnd and YEnd become 0.

// They are the ammount of canvas to be added or subtracted from
// the beggining and/or the end in horizontal and/or vertical positions.

   dec(Width);
   dec(Height);

   While XBegin > 0 do
   begin
      inc(Width);
      SetLength(Frame,Width * Height);
      CanvasPushHorizontal(Frame,Width,Height,1);
      CanvasCreateEmptyHorizontalQueue(Frame,Width,0,PaletteColour);
   end;
   While (XBegin < 0) and (Width > 0) do
   begin
      CanvasPullHorizontal(Frame,Height,Width);
      dec(Width);
      SetLength(Frame,Width * Height);
   end;
   While (XEnd > 0) do
   begin
      inc(Width);
      SetLength(Frame,Width * Height);
      CanvasCreateEmptyHorizontalQueue(Frame,Width,Width+1,PaletteColour);
   end;
   While (XEnd < 0) and (Width > 0) do
   begin
      dec(Width);
      SetLength(Frame,Width * Height);
   end;
   While (YBegin > 0) do
   begin
      inc(Height);
      SetLength(Frame,Width * Height);
      CanvasPushVertical(Frame,Width,Height,1);
      CanvasCreateEmptyVerticalQueue(Frame,Height,0,PaletteColour);
   end;
   While (YBegin < 0) and (Height > 0) do
   begin
      CanvasPullVertical(Frame,Width,Height);
      dec(Height);
      SetLength(Frame,Width * Height);
   end;
   While (YEnd > 0) do
   begin
      inc(Height);
      SetLength(Frame,Width * Height);
      CanvasCreateEmptyVerticalQueue(Frame,Height,Height+1,PaletteColour);
   end;
   While (YEnd < 0) and (Height > 0) do
   begin
      dec(Height);
      SetLength(Frame,Width * Height);
   end;
end;

// The four procedures below works in a recursive way.
Procedure CanvasPullHorizontal(var Frame:TFrameImage; MaxHeight,Position:Integer);
var
   y:integer;
begin
   // This works in a simple way:

   // If the position is -1 it does nothing
   // Otherwise, it copies the following position into the current one
   if Position >= 0 then
   begin
      CanvasPullHorizontal(Frame,MaxHeight,Position-1);
      // copy previous position to current one
      for y:= 0 to MaxHeight do
         Frame[position,y] := Frame[position+1,y];
   end;
end;

Procedure CanvasPushHorizontal(var Frame:TFrameImage; MaxWidth,MaxHeight,Position:Integer);
var
   y:integer;
begin
   // This works in a simple way:

   // If the position is bigger than the max width, it does nothing
   // Otherwise, it copies the previous position into the current one
   if Position <= MaxWidth then
   begin
      CanvasPushHorizontal(Frame,MaxWidth,MaxHeight,Position+1);
      // copy previous position to current one
      for y:= 0 to MaxHeight do
         Frame[position,y] := Frame[position-1,y];
   end;
end;

Procedure CanvasPullVertical(var Frame:TFrameImage; MaxWidth,Position:Integer);
var
   x:integer;
begin
   // This works in a simple way:

   // If the position is -1 it does nothing
   // Otherwise, it copies the following position into the current one
   if Position >= 0 then
   begin
      CanvasPullVertical(Frame,MaxWidth,Position-1);
      // copy previous position to current one
      for x:= 0 to MaxWidth do
         Frame[x,position] := Frame[x,position+1];
   end;
end;

Procedure CanvasPushVertical(var Frame:TFrameImage; MaxWidth,MaxHeight,Position:Integer);
var
   x:integer;
begin
   // This works in a simple way:

   // If the position is bigger than the max height, it does nothing
   // Otherwise, it copies the previous position into the current one
   if Position <= MaxHeight then
   begin
      CanvasPushVertical(Frame,MaxWidth,MaxHeight,Position+1);
      // copy previous position to current one
      for x:= 0 to MaxWidth do
         Frame[x,position] := Frame[x,position-1];
   end;
end;

// Create empty queues, very easy to understand
Procedure CanvasCreateEmptyHorizontalQueue(var Frame:TFrameImage; MaxWidth,Position:Integer; PaletteColour:Byte);
var
   x:integer;
begin
   for x := 0 to MaxWidth do
      Frame[x,position] := PaletteColour;

end;

Procedure CanvasCreateEmptyVerticalQueue(var Frame:TFrameImage; MaxHeight,Position:Integer; PaletteColour:Byte);
var
   y:integer;
begin
   for y := 0 to MaxHeight do
      Frame[position,y] := PaletteColour;

end;

// Drawing Procedures
// Misc

// Turns a colour to grayscale
Function colourtogray(colour : cardinal): cardinal;
var
temp : char;
begin
  temp := char((GetBValue(colour)*29 + GetGValue(colour)*150 + GetRValue(colour)*77) DIV 256);
  Result := RGB(ord(temp),ord(temp),ord(temp));
end;

// Data From DataBuffer

Procedure DrawImageWithShadow(SHP: TSHP; Frame: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
begin

if HasShadows(SHP) then  // Make sure SHP has shadows
begin
DrawImage(SHP,GetShadowFromOposite(SHP,Frame),true,false,Palette,Image1); // Draw Shadow
DrawImage(SHP,Frame,false,GrayScale,Palette,Image1); // Draw Owner
end
else
DrawImage(SHP,Frame,true,GrayScale,Palette,Image1); // Draw Owner


end;

Procedure DrawShadowWithImage(SHP: TSHP; Frame: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
begin
if HasShadows(SHP) then  // Make sure SHP has shadows
begin
DrawImage(SHP,Frame,true,false,Palette,Image1);
DrawImage(SHP,GetShadowOposite(SHP,frame),false,GrayScale,Palette,Image1);
end
else
DrawImage(SHP,Frame,true,GrayScale,Palette,Image1); // Draw Owner
end;

Procedure DrawImage(SHP: TSHP; Frame: integer; Flood,Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
var
x,y,c,xx,yy : integer;
begin

// Check to see frame is not above the number of images
if Frame > shp.Header.NumImages then
Exit;

//check to see it is not below 1  (images start at 1)
if Frame < 1 then
Exit;

     // Set image width n height
     image1.Picture.Bitmap.Width := SHP.header.Width;
     image1.Picture.Bitmap.Height := SHP.header.Height;

     // Get the position of where to draw the frame from
     xx := SHP.Data[Frame].header_image.x;
     yy := SHP.Data[Frame].header_image.y;

     // Clear the image of colour (fills with the transparent colour)
     image1.Picture.Bitmap.Canvas.Brush.Color := palette[TRANSPARENT];
     if flood then // Only clear image if flood is set to true
     image1.Picture.Bitmap.Canvas.FillRect(rect(0,0,image1.Picture.Bitmap.Width,image1.Picture.Bitmap.Height));
     c := -1;

     // Populate the image pixel by pixel
     for y := 0 to shp.data[Frame].header_image.cy-1 do
     for x := 0 to shp.data[Frame].header_image.cx-1 do
     begin
     c := c +1;

     if shp.data[Frame].databuffer[c] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     if grayscale then
     image1.Picture.Bitmap.Canvas.Pixels[xx+x,yy+y] := colourtogray(palette[shp.data[Frame].databuffer[c]])
     else
     image1.Picture.Bitmap.Canvas.Pixels[xx+x,yy+y] := palette[shp.data[Frame].databuffer[c]];
     end;


end;


// Data From FrameImage

Procedure DrawFrameImage(SHP: TSHP; Frame, Zoom: integer; Flood,Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
var
x,y : integer;
begin

// Check to see frame is not above the number of images
if Frame > shp.Header.NumImages then
Exit;

//check to see it is not below 1  (images start at 1)
if Frame < 1 then
Exit;

// Zoom can't be 0.
if Zoom < 1 then
Zoom := 1;

     // Set image width n height
     image1.Picture.Bitmap.Width := SHP.header.Width*zoom;
     image1.Picture.Bitmap.Height := SHP.header.Height*zoom;

     // Clear the image of colour (fills with the transparent colour)
     image1.Picture.Bitmap.Canvas.Brush.Color := palette[TRANSPARENT];
     if flood then // Only clear image if flood is set to true
     image1.Picture.Bitmap.Canvas.FillRect(rect(0,0,image1.Picture.Bitmap.Width,image1.Picture.Bitmap.Height));

     // Populate the image pixel by pixel
     if zoom > 1 then
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if grayscale then
     image1.Picture.Bitmap.Canvas.Brush.Color := colourtogray(palette[shp.data[Frame].frameimage[x,y]])
     else
     image1.Picture.Bitmap.Canvas.Brush.Color := palette[shp.data[Frame].frameimage[x,y]];

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     image1.Picture.Bitmap.Canvas.FillRect(Rect((x*zoom),(y*zoom),(x*zoom)+zoom,(y*zoom)+zoom));
     end
     else
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     if grayscale then
     image1.Picture.Bitmap.Canvas.Pixels[x,y] := colourtogray(palette[shp.data[Frame].frameimage[x,y]])
     else
     image1.Picture.Bitmap.Canvas.Pixels[x,y] := palette[shp.data[Frame].frameimage[x,y]];
     end;


end;

Procedure DrawFrameImageWithShadow(SHP: TSHP; Frame, Zoom: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
begin
DrawFrameImage(SHP,GetShadowFromOposite(SHP,Frame),Zoom,true,false,Palette,Image1); // Draw Shadow
DrawFrameImage(SHP,Frame,Zoom,false,GrayScale,Palette,Image1); //Draw Owner
end;

Procedure DrawShadowWithFrameImage(SHP: TSHP; Frame, Zoom: integer; Grayscale : boolean; Palette: TPalette; var Image1 : Timage);
begin
DrawFrameImage(SHP,Frame,Zoom,true,false,Palette,Image1); // Draw Shadow
DrawFrameImage(SHP,GetShadowOposite(SHP,frame),Zoom,false,GrayScale,Palette,Image1); //Draw Owner
end;

// Drawing Using TPaintBox Canvas insted of TImage

Procedure DrawFrameImageCanvas(SHP: TSHP; Frame, Zoom: integer; Flood,Grayscale : boolean; Palette: TPalette; var PaintBox : TPaintBox);
var
x,y : integer;
begin

// Check to see frame is not above the number of images
if Frame > shp.Header.NumImages then
Exit;

//check to see it is not below 1  (images start at 1)
if Frame < 1 then
Exit;

// Zoom can't be 0.
if Zoom < 1 then
Zoom := 1;


     // Clear the image of colour (fills with the transparent colour)
     PaintBox.Canvas.Brush.Color := palette[TRANSPARENT];
     if flood then // Only clear image if flood is set to true
     PaintBox.Canvas.FillRect(rect(0,0,SHP.header.Width*zoom,SHP.header.Height*zoom));

     // Populate the image pixel by pixel
     if zoom > 1 then
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if grayscale then
     PaintBox.Canvas.Brush.Color := colourtogray(palette[shp.data[Frame].frameimage[x,y]])
     else
     PaintBox.Canvas.Brush.Color := palette[shp.data[Frame].frameimage[x,y]];

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     PaintBox.Canvas.FillRect(Rect((x*zoom),(y*zoom),(x*zoom)+zoom,(y*zoom)+zoom));
     end
     else
     for y := 0 to SHP.header.Height-1 do
     for x := 0 to SHP.header.Width-1 do
     begin

     if shp.data[Frame].frameimage[x,y] <> TRANSPARENT then // Stops it drawing transparent colours, stops shadows oposite form drawing over shadow
     if grayscale then
     PaintBox.Canvas.Pixels[x,y] := colourtogray(palette[shp.data[Frame].frameimage[x,y]])
     else
     PaintBox.Canvas.Pixels[x,y] := palette[shp.data[Frame].frameimage[x,y]];
     end;


end;

//Cameo Procedures/Fuctions
procedure DrawCameoBar_TextBar(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawDark_Cameo(SHP,Value,ALG,0,SHP.Header.Width-1,SHP.Header.Height-7,SHP.Header.Height-1);
end;

procedure DrawCameoBar_TextBar2(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawDark_Cameo(SHP,Value,ALG,0,SHP.Header.Width-1,SHP.Header.Height-13,SHP.Header.Height-1);
end;

procedure DrawCameoBar_DarkSide_Blade(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawDark_Cameo(SHP,Value,ALG,0,0,2,SHP.Header.Height-3);
end;

procedure DrawCameoBar_LightSide_Blade(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawLight_Cameo(SHP,Value,ALG,SHP.Header.Width-2,SHP.Header.Width-2,1,SHP.Header.Height-2);
end;

procedure DrawCameoBar_LightTop_Blade(var SHP:TSHP; Value : byte; ALG : integer);
var
x,y : integer;
c : tcolor;
r,g,b : byte;
begin


DrawLight_Cameo(SHP,Value,ALG,4,33,1,2);
DrawLight_Cameo(SHP,Value,ALG,34,34,2,2);

for x := 1 to 3 do
for y := 1 to 2 do
if Not((x = 1) and (y = 1)) then
begin
c := SHPPalette[SHP.Data[1].FrameImage[34,2]];

R := GetRValue(c);
G := GetGValue(c);
B := GetBValue(c);

if r + Value*2 > 255 then
r := 255
else
r := r + Value*2;

if g + Value*2 > 255 then
g := 255
else
g := g + Value*2;

if b + Value*2 > 255 then
b := 255
else
b := b + Value*2;

SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,RGB(r,g,b),SHPPalette[0],ALG,false,false,false);
end;

end;

procedure DrawCameo_Transparent(var SHP:TSHP);
var
W,H : integer;
begin

W := SHP.Header.Width-1;
H := SHP.Header.Height-1;

SHP.Data[1].FrameImage[0,0] := 0;
SHP.Data[1].FrameImage[0,1] := 0;
SHP.Data[1].FrameImage[1,0] := 0;

SHP.Data[1].FrameImage[W,H] := 0;
SHP.Data[1].FrameImage[W-1,H] := 0;
SHP.Data[1].FrameImage[W,H-1] := 0;

SHP.Data[1].FrameImage[W,0] := 0;
SHP.Data[1].FrameImage[W,1] := 0;
SHP.Data[1].FrameImage[W-1,0] := 0;

SHP.Data[1].FrameImage[0,H] := 0;
SHP.Data[1].FrameImage[1,H] := 0;
SHP.Data[1].FrameImage[0,H-1] := 0;
end;

Procedure DrawEliteIconRA2(var SHP:TSHP; const ImageList : TImageList; EI, ALG : integer);
var
Bitmap : TBitmap;
x,y : integer;
begin
Bitmap := TBitmap.Create;

Bitmap.Width := ImageList.Width+1;
Bitmap.Height := ImageList.Height+1;

ImageList.Draw(Bitmap.Canvas,0,0,EI);

for x := 2 to ImageList.Width+1 do
for y := 2 to ImageList.Height+1 do
if Bitmap.Canvas.Pixels[x-2,y-2] <> clblue then
SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,Bitmap.Canvas.Pixels[x-2,y-2],SHPPalette[0],ALG,false,false,false);

Bitmap.Free;
end;

function WorkOutCharLength(Index : Integer; ImageList : TImageList) : integer;
var
Bitmap : tbitmap;
x,y : integer;
f : boolean;
begin
Bitmap := TBitmap.Create;
Bitmap.Width := ImageList.Width;
Bitmap.Height := ImageList.Height;

ImageList.Draw(Bitmap.Canvas,0,0,Index);

x := 2;

for y := 0 to 5 do
if Bitmap.Canvas.Pixels[2,y] <> clblue then
x := 3;

for y := 0 to 5 do
if Bitmap.Canvas.Pixels[3,y] <> clblue then
x := 4;

for y := 0 to 5 do
if Bitmap.Canvas.Pixels[4,y] <> clblue then
x := 5;

for y := 0 to 5 do
if Bitmap.Canvas.Pixels[5,y] <> clblue then
x := 6;

Result := x;
Bitmap.Free;
end;

Procedure AddCharToBMP(Var Bitmap : TBitmap; Const Text : String; Index : Integer; ImageList : TImageList);
var
C : String[1];
I,X,W : integer;
begin
Bitmap.Height := ImageList.Height;

C := ansiuppercase(copy(Text,Index,1));

I := -1;

for X := 0 to 9 do
if C = inttostr(X) then
I := X;

for x := 65 to 65+25 do
if C = char(X) then
I := X-65+10;

if C = '.' then
I := 36;


If C = ' ' then
I := -2;

if I = -1 then
exit; // Illegal charactor exit;

W := Bitmap.Width;
if I = -2 then
Bitmap.Width := Bitmap.Width+3
else
Bitmap.Width := Bitmap.Width+WorkOutCharLength(I,ImageList);

if I > 0 then
ImageList.Draw(Bitmap.Canvas,W,0,I);
end;

Procedure AddCharToBMP2(Var Bitmap : TBitmap; Const Text : String; Index : Integer; ImageList : TImageList);
var
C : String[1];
I,X,W : integer;
begin
Bitmap.Height := ImageList.Height;

C := ansiuppercase(copy(Text,Index,1));

I := -1;

for X := 0 to 9 do
if C = inttostr(X) then
I := X;

for x := 65 to 65+25 do
if C = char(X) then
I := X-65+10;

if C = '.' then
I := 36;


If C = ' ' then
I := -2;

if I = -1 then
exit; // Illegal charactor exit;

if (I <> -2) and (I <> 36) then
I := I +38;

W := Bitmap.Width;
if I = -2 then
Bitmap.Width := Bitmap.Width+3
else
Bitmap.Width := Bitmap.Width+WorkOutCharLength(I,ImageList);

if I > 0 then
ImageList.Draw(Bitmap.Canvas,W,0,I);
end;

Procedure DrawCameoText(Var SHP:TSHP; Const Text : string; ImageList : TImageList; ALG : integer);
var
Bitmap : TBitmap;
x,y,c : integer;
begin
Bitmap := TBitmap.Create;
Bitmap.Canvas.Brush.Color := clblue;

for x := 1 to length(Text) do
AddCharToBMP(Bitmap,Text,x,ImageList);

c := ((SHP.Header.Width) div 2) - ((Bitmap.Width) div 2);

if Bitmap.Width > SHP.Header.Width then
begin
Bitmap.Width := SHP.Header.Width;
c := 0;
end;


for x := c to c+Bitmap.Width-1 do
for y := 42 to 47 do
if Bitmap.Canvas.Pixels[x-c,y-42] <> clblue then
SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,Bitmap.Canvas.Pixels[x-c,y-42],SHPPalette[0],ALG,false,false,false);


Bitmap.Free;
end;

Procedure DrawCameoText2(Var SHP:TSHP; Const Text : string; ImageList : TImageList; ALG : integer);
var
Bitmap : TBitmap;
x,y,c : integer;
begin
Bitmap := TBitmap.Create;
Bitmap.Canvas.Brush.Color := clblue;

for x := 1 to length(Text) do
AddCharToBMP2(Bitmap,Text,x,ImageList);

c := ((SHP.Header.Width) div 2) - ((Bitmap.Width) div 2);

if Bitmap.Width > SHP.Header.Width then
begin
Bitmap.Width := SHP.Header.Width;
c := 0;
end;


for x := c to c+Bitmap.Width-1 do
for y := (SHP.Header.height-12) to (SHP.Header.height-7) do
if Bitmap.Canvas.Pixels[x-c,y-(SHP.Header.height-12)] <> clblue then
SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,Bitmap.Canvas.Pixels[x-c,y-(SHP.Header.height-12)],SHPPalette[0],ALG,false,false,false);


Bitmap.Free;
end;

procedure DrawDark_Cameo(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
var
x,y : integer;
c : tcolor;
r,g,b : byte;
begin

for x := x1 to x2 do
for y := y1 to y2 do
begin
c := SHPPalette[SHP.Data[1].FrameImage[x,y]];

R := GetRValue(c);
G := GetGValue(c);
B := GetBValue(c);

if r - Value < 0 then
r := 0
else
r := r - Value;

if g - Value < 0 then
g := 0
else
g := g - Value;

if b - Value < 0 then
b := 0
else
b := b - Value;

SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,RGB(r,g,b),SHPPalette[0],ALG,false,false,false);
end;

end;

procedure DrawLight_Cameo(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
var
x,y : integer;
c : tcolor;
r,g,b : byte;
begin

for x := x1 to x2 do
for y := y1 to y2 do
begin
c := SHPPalette[SHP.Data[1].FrameImage[x,y]];

R := GetRValue(c);
G := GetGValue(c);
B := GetBValue(c);

if r + Value > 255 then
r := 255
else
r := r + Value;

if g + Value > 255 then
g := 255
else
g := g + Value;

if b + Value > 255 then
b := 255
else
b := b + Value;

SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,RGB(r,g,b),SHPPalette[0],ALG,false,false,false);
end;

end;

procedure DrawLight_Cameo2(var SHP:TSHP; Value : byte; ALG,X1,X2,Y1,Y2 : integer);
var
x,y,xv,yv : integer;
c : tcolor;
r,g,b,v,step : byte;
begin

XV := X2-X1;
if XV = 0 then
XV := 1;

YV := Y2-Y1;
if YV = 0 then
YV := 1;

step := value div (XV*YV);

v := value;

for x := x1 to x2 do
for y := y1 to y2 do
begin
c := SHPPalette[SHP.Data[1].FrameImage[x,y]];

R := GetRValue(c);
G := GetGValue(c);
B := GetBValue(c);

if r + v > 255 then
r := 255
else
r := r + v;

if g + v > 255 then
g := 255
else
g := g + v;

if b + v > 255 then
b := 255
else
b := b + v;

SHP.Data[1].FrameImage[x,y] := getpalettecolour2(SHPPalette,RGB(r,g,b),SHPPalette[0],ALG,false,false,false);

v := v-step;
if v < 0 then v := 0;
end;

end;

procedure DrawCameoBar_DarkSides_s1(var SHP:TSHP; Value : byte; ALG : integer);
begin

DrawDark_Cameo(SHP,Value*2,alg,0,0,2,SHP.Header.Height-3);
DrawDark_Cameo(SHP,Value,alg,1,1,1,SHP.Header.Height-2);

{DrawDark_Cameo(SHP,Value*2,alg,SHP.Header.Width-1,SHP.Header.Width-1,2,SHP.Header.Height-3);
DrawDark_Cameo(SHP,Value,alg,SHP.Header.Width-2,SHP.Header.Width-2,2,SHP.Header.Height-3); }

DrawDark_Cameo(SHP,Value*2,alg,2,SHP.Header.Width-3,0,0);
DrawDark_Cameo(SHP,Value,alg,1,SHP.Header.Width-2,1,1);

{DrawDark_Cameo(SHP,Value*2,alg,2,SHP.Header.Width-3,SHP.Header.Height-1,SHP.Header.Height-1);
DrawDark_Cameo(SHP,Value,alg,2,SHP.Header.Width-3,SHP.Header.Height-2,SHP.Header.Height-2);}
end;

procedure DrawCameoBar_LightSides_s1(var SHP:TSHP; Value : byte; ALG : integer);
begin

DrawLight_Cameo(SHP,Value,alg,SHP.Header.Width-1,SHP.Header.Width-1,2,SHP.Header.Height-3);
//DrawLight_Cameo(SHP,Value*2,alg,SHP.Header.Width-2,SHP.Header.Width-2,1,SHP.Header.Height-2);

{DrawLight_Cameo(SHP,Value*2,alg,2,SHP.Header.Width-3,SHP.Header.Height-1,SHP.Header.Height-1);
DrawLight_Cameo(SHP,Value,alg,2,SHP.Header.Width-3,SHP.Header.Height-2,SHP.Header.Height-2);    }
end;

procedure DrawCameoBar_DarkSides_s2(var SHP:TSHP; Value : byte; ALG : integer);
begin

DrawDark_Cameo(SHP,Value*2,alg,0,0,2,SHP.Header.Height-3);
DrawDark_Cameo(SHP,Value,alg,1,1,1,SHP.Header.Height-2);

DrawDark_Cameo(SHP,Value*2,alg,SHP.Header.Width-1,SHP.Header.Width-1,2,SHP.Header.Height-3);
DrawDark_Cameo(SHP,Value,alg,SHP.Header.Width-2,SHP.Header.Width-2,1,SHP.Header.Height-2);

DrawLight_Cameo(SHP,Value*2,alg,2,SHP.Header.Width-3,0,0);
end;

procedure DrawCameoBar_LightSides_s2(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawLight_Cameo(SHP,Value,alg,2,SHP.Header.Width-3,0,0);
end;

procedure DrawCameoBar_Kravvitz(var SHP:TSHP; Value : byte; ALG : integer);
begin

DrawLight_Cameo2(SHP,Value,alg,1,1,2,SHP.Header.Height-2);
DrawLight_Cameo2(SHP,Value,alg,2,2,2,17);

DrawLight_Cameo2(SHP,Value,alg,2,SHP.Header.Width-2,1,1);
DrawLight_Cameo2(SHP,Value,alg,2,30,2,2);
DrawLight_Cameo2(SHP,Value,alg,2,4,3,3);

DrawLight_Cameo2(SHP,Value,alg,SHP.Header.Width-2,SHP.Header.Width-2,2,SHP.Header.Height-2);
DrawLight_Cameo2(SHP,Value div 2,alg,SHP.Header.Width-1,SHP.Header.Width-1,2,SHP.Header.Height-2);
end;

procedure DrawCameoBar_Kravvitz2(var SHP:TSHP; Value : byte; ALG : integer);
begin
DrawLight_Cameo2(SHP,Value,alg,1,1,2,SHP.Header.Height-2);
DrawLight_Cameo2(SHP,Value,alg,2,2,2,17);

DrawLight_Cameo2(SHP,Value,alg,2,SHP.Header.Width-2,1,1);
DrawLight_Cameo2(SHP,Value,alg,2,30,2,2);
DrawLight_Cameo2(SHP,Value,alg,2,4,3,3);
end;

Function WorkOutTextBarDV(SHP:TSHP) : integer;
var
x,y,RGBA,A,C : integer;
r,g,b : byte;
begin

A := 0;
C := 0;

for x := 0 to shp.Header.Width-1 do
for y := shp.Header.Height-7 to shp.Header.Height-1 do
begin
C := C + 1;

R := GetRValue(SHPPalette[SHP.data[1].FrameImage[x,y]]);
G := GetGValue(SHPPalette[SHP.data[1].FrameImage[x,y]]);
B := GetBValue(SHPPalette[SHP.data[1].FrameImage[x,y]]);

RGBA := (R+G+B) Div 3;

A := A + RGBA;
end;

A := A div C;

Result := A;
end;

// Modifyed ver of AntiAliasRect from janFX by Jan Verhoeven
Function AntiAlias_S2(Bitmap: tbitmap;BGColour : TColor) : TBitmap;
var x,y: Integer;
    p0,p1,p2,r1:pbytearray;
    p01,p02,p03,p21,p22,p23,p31,p32,p33,p41,p42,p43 : byte;
begin
   Bitmap.PixelFormat := pf24bit;
   Result := TBitmap.Create;
   Result.Width := Bitmap.Width;
   Result.Height := Bitmap.Height;
   Result.PixelFormat := pf24bit;

   Result.Canvas.Brush.Color := BGColour;
   Result.Canvas.FillRect(Rect(0,0,Result.Width,Result.Height));

   for y:=1 to Result.height-2 do begin
    p0:=Bitmap.ScanLine[y-1];
    p1:=Bitmap.scanline[y];
    p2:=Bitmap.ScanLine[y+1];
    r1:=Result.ScanLine[y];
    for x:=1 to Result.width-2 do
    if RGB(p1[x*3+2],p1[x*3+1],p1[x*3]) <> BGColour then
      begin

      // Should stop BG Interfearence
      if RGB(p0[x*3+2],p0[x*3+1],p0[x*3]) <> BGColour then
      begin
      p01 := p0[x*3];
      p02 := p0[x*3+1];
      p03 := p0[x*3+2];
      end
      else
      begin
      p01 := p1[x*3];
      p02 := p1[x*3+1];
      p03 := p1[x*3+2];
      end;

      // Should stop BG Interfearence
      if RGB(p2[x*3+2],p2[x*3+1],p2[x*3]) <> BGColour then
      begin
      p21 := p2[x*3];
      p22 := p2[x*3+1];
      p23 := p2[x*3+2];
      end
      else
      begin
      p21 := p1[x*3];
      p22 := p1[x*3+1];
      p23 := p1[x*3+2];
      end;

      // Should stop BG Interfearence
      if RGB(p1[(x-1)*3+2],p1[(x-1)*3+1],p1[(x-1)*3]) <> BGColour then
      begin
      p31 := p1[(x-1)*3];
      p32 := p1[(x-1)*3+1];
      p33 := p1[(x-1)*3+2];
      end
      else
      begin
      p31 := p1[x*3];
      p32 := p1[x*3+1];
      p33 := p1[x*3+2];
      end;

      // Should stop BG Interfearence
      if RGB(p1[(x+1)*3+2],p1[(x+1)*3+1],p1[(x+1)*3]) <> BGColour then
      begin
      p41 := p1[(x+1)*3];
      p42 := p1[(x+1)*3+1];
      p43 := p1[(x+1)*3+2];
      end
      else
      begin
      p41 := p1[x*3];
      p42 := p1[x*3+1];
      p43 := p1[x*3+2];
      end;

      r1[x*3]:=(p01+p21+p31+p41)div 4;
      r1[x*3+1]:=(p02+p22+p32+p42)div 4;
      r1[x*3+2]:=(p03+p23+p33+p43)div 4;
      end;
   end;
end;

function AutoSelectALG(Bitmap : TBitmap; BGColour : TColor; BcNone,ssShadow,ssIgnoreLAstColours : Boolean) : byte;
var
Diff,difft,x : integer;
alg : byte;
begin
diff := 999999999; // Max value
for x := 1 to MaxAlg do
begin
difft := SetFrameImageFrmBMP2Diff(1,SHPPalette,Bitmap,BGColour,x,bcNone,ssShadow,ssIgnoreLastColours);
if difft < diff then
begin
diff := difft;
alg := x;
end;
end;

Result := alg;
end;

function AutoSelectALG_Progress(ProgressBar : TProgressBar; Bitmap : TBitmap; BGColour : TColor; BcNone,ssShadow,ssIgnoreLAstColours : Boolean) : byte;
var
Diff,difft,x : integer;
alg : byte;
begin
diff := 999999999; // Max value
ProgressBar.Visible := true;
ProgressBar.Max := MaxAlg-1;
for x := 1 to MaxAlg do
begin
ProgressBar.Position := x-1;
ProgressBar.Refresh;
difft := SetFrameImageFrmBMP2Diff(1,SHPPalette,Bitmap,BGColour,x,bcNone,ssShadow,ssIgnoreLastColours);
if difft < diff then
begin
diff := difft;
alg := x;
end;
end;

Result := alg;
end;

end.
 