// SHP_FILE.PAS
// By Banshee & Stucuk
// Portions Of XCC Code were converted from C to Delphi

unit Shp_File;

interface

uses
  Graphics;

type
  TRGB32 = packed record
    B, G, R, A: Byte;
  end;
  TRGB32Array = packed array[0..MaxInt div SizeOf(TRGB32)-1] of TRGB32;
  PRGB32Array = ^TRGB32Array;

TTempView_Item = record
        X : integer;
        Y : integer;
        colour : tcolor;
        colour_used:boolean;
end;

TTempView = array of TTempView_Item;

TDatabuffer = array of byte;

THeader = record
             A : word; {Unknown}
             Width,Height,    {Width and Height of the images}
             NumImages : word;{Number of images}
end;

THeader_Image = record
             x,y,cx,cy          : word; {cx and cy are width n height of stored image}
             compression,unknown,zero,offset        : longint; {Unknown}
end;

TFrameImage = array of array of Byte;

TSHPData = record
        Header_Image : THeader_Image;
        Databuffer : TDatabuffer;
        FrameImage : TFrameImage;
end;

TSHPType = (stUnit,stBuilding,stCameo,stAnimation,sttem,stsno);

TSHP = record
        SHPType : TSHPType;
        Header : THeader;
        Data : array of TSHPDATA;
end;

TSelectArea = record
  X1,Y1,X2,Y2 : integer;
end;

Procedure Decode3(const Source : Tdatabuffer; var Dest : Tdatabuffer; const cx,cy : integer);

implementation

Procedure Decode3(const Source : Tdatabuffer; var Dest : Tdatabuffer; const cx,cy : integer);
var
SP,DP,x,y,count,v,max : integer;
begin

max := cx * cy;

SP :=0;
DP :=0;
Count :=0;

for y := 0 to cy-1 do
begin
count := Source[SP]-2;
SP := SP +2;
x := 0;
while count >0 do
begin

     dec(count);
     v := Source[SP];
     Inc(SP);
     if v <> 0 then
     begin
     inc(x);
     Dest[DP] := v;
     Inc(DP);
     end
     else
     begin
     dec(count);
     v := Source[SP];
     Inc(SP);
     if (x + v) > cx then
     v := cx - x;
     x := x + v;
     while v >0 do
     begin
     dec(v);
     Dest[DP] := 0;
     Inc(DP);
     if (SP > max) or (DP > max) then
     exit; // SP or DP has reached max value, exit
     end;
     end;
end;

if (SP >= max) or (DP >= max) then
exit; // SP or DP has reached max value, exit

end;

end;

end.
 